require "spec_helper"

RSpec.describe "Snake Params" do
  it "recursively snake cases parameters" do
    class ExampleController1
      def self.before_action(_); end

      def params
        {
          "thisIsA" => "test",
          "ofParameters" => {
            # Make sure we don't convert values, just keys:
            "thatAre" => "camelCased",
            "that" => {
              "shouldBe" => "converted"
            }
          },
          "to" => [
            { "snakeCased" => "1" },
            { "parameters" => "2" }
          ]
        }
      end

      include ::SnakeParams

      def action
        deep_snake_case_params!
      end
    end

    controller = ExampleController1.new

    expect(controller.action).to eq(
      "this_is_a" => "test",
      "of_parameters" => {
        "that_are" => "camelCased",
        "that" => {
          "should_be" => "converted"
        }
      },
      "to" => [
        { "snake_cased" => "1" },
        { "parameters" => "2" }
      ]
    )
  end

  it "attaches to before_action" do
    class ExampleController2
      def self.before_action(_); end
    end

    expect(ExampleController2).
      to receive(:before_action).
      with(:deep_snake_case_params!)

    class ExampleController2
      include ::SnakeParams
    end
  end
end
